<?php
require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture.class.php';
require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture-rec.class.php';
require_once DOL_DOCUMENT_ROOT . '/compta/paiement/class/paiement.class.php';
require_once 'renew.class.php';
$res = 0;
if (! $res && file_exists(DOL_DOCUMENT_ROOT."/custom/contratplus/core/function.php")) {
	$res = @include(DOL_DOCUMENT_ROOT."/custom/contratplus/core/function.php");
}
if (! $res && file_exists(DOL_DOCUMENT_ROOT."/contratplus/core/function.php")) {
	$res = @include(DOL_DOCUMENT_ROOT."/contratplus/core/function.php");
}
if (! $res) die("Include of contratplus/function.php fails");

class Actionscontratplus
{
    var $db;
    var $error;
    var $errors=array();

    function __construct($db)
    {
        $this->db = $db;
    }

    /**
     * ContractCard is Dolibarr hook context of contrat/card.php for doActions hook
     *
     * @param   CommonObject    $object     The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
     * @param   string          $action     Current action (if set). Generally create or edit or null
     * @param   string          $option     Current option chosen by user
     * @param   Database        $db         The object given by dolibarr global (global $db)
     * @param   User            $user       The object given by dolibarr global (global $user)
     */
    private function actionContextContractCard($object, $action, $option, $db, $user)
    {
        global $conf;

        /* check bypass */
        if ($action == "confirm_renewal")
        {
            $renew = new Renew($db, $conf, $user);
            $renew->renewSimple(intval($option), $object->id);
        }
    }

    /**
     * Overloading the doActions function : replacing the parent's function with the one below
     *
     * @param   array()         $parameters     Hook metadatas (context, etc...)
     * @param   CommonObject    $object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
     * @param   string          $action        Current action (if set). Generally create or edit or null
     * @param   HookManager     $hookmanager    Hook manager propagated to allow calling another hook
     * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
     */
    function doActions($parameters, &$object, &$action, $hookmanager)
	{
		global $user, $db, $conf;

		// find chosen option
		$option = getOption($db);

		if ($parameters['currentcontext'] == 'contractcard')
		{
		    $this->actionContextContractCard($object, $action, $option, $db, $user);
		}
		return 0;
	}

    /**
     * ContractCard is Dolibarr hook context of contrat/card.php for addMoreActionsButtons hook
     *
     * @param   CommonObject    $object     The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
     * @param   string          $action     Current action (if set). Generally create or edit or null
     * @param   Lang            $langs      The object given by dolibarr global (global $langs)
     * @param   Form            $form       The object given by dolibarr global (global $form)
     * @param   Conf            $conf       The object given by dolibarr global (global $conf)
     */
    private function buttonContextContractCard($object, $action, $langs, $form, $conf)
    {
        global $user;

        if ($action == "renewal")
        {
            if ($conf->global->CONTRATPLUS_BYPASS == 1)
                header ("Location: ".$_SERVER['PHP_SELF']."?id=".$object->id."&action=confirm_renewal");
            else {
                $langs->trans("Contratname",$object->ref);
                $text = $langs->trans("RenewalConfirmation");
                $check = 0;
                $i = 0;
                while ($i < count($object->lines))
                {
                    if ($object->lines[$i]->statut == 4)
                    {
                        $date1 = strtotime(date("Y-m-d"));
                        $date2 = strtotime(date("Y-m-d", strtotime($object->lines[$i]->date_fin_validite)));
                        if ($date1 > $date2)
                        {
                            $new_text = $langs->trans('contratPlusDetailService', $i + 1, $object->lines[$i]->ref, date("Y-m-d", $conf->global->CONTRATPLUS_DATE_END));
                            $text = $text.$new_text;
                            $check++;
                        }
                    }
                    $i++;
                }

                if ($check == 0)
                    $text .= $langs->trans("NoServices");

                print $form->formconfirm($_SERVER['PHP_SELF']."?id=".$object->id, $langs->trans("ConfirmRenewal"), $text, "confirm_renewal", '', 0, 1);
            }
        }

        if ($object->statut == 1 && $object->element == "contrat")
        {

            $supplier_ok = true;
            if ($conf->global->CONTRATPLUS_SUPPLIER_CONTRACT == 1 && $object->array_options['options_supplier_contract'] == '1')
            {
                $supplier_ok = false;
                if ($user->rights->fournisseur->facture->lire
                    && $user->rights->fournisseur->facture->creer
                    && $user->rights->fournisseur->facture->creer)
                    $supplier_ok = true;
            }
            if (isAuthorize(getOption($this->db), $user) && $supplier_ok)
                print '<div class="inline-block divButAction"><a class="butAction" href="' .
                    $_SERVER["PHP_SELF"] . '?id=' . $object->id . '&amp;action=renewal">' .
                    $langs->trans("Renewal").'</a></div>';
            else
                print '<div class="inline-block divButAction"><a class="butActionRefused" href="#">' .
                    $langs->trans("Renewal").'</a></div>';

        }

    }

    /**
     * GlobalCard is Dolibarr hook context of all card.php for addMoreActionsButtons hook
     *
     * @param   CommonObject    $object     The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...)
     * @param   Lang            $langs      The object given by dolibarr global (global $langs)
     * @param   Conf            $conf       The object given by dolibarr global (global $conf)
     */
    private function buttonContextGlobalCard($object, $langs, $conf)
    {
        global $user;

        if ($conf->global->CONTRATPLUS_SUPPLIER_CONTRACT)
        {
            if ($object->next_prev_filter == 'te.fournisseur = 1')
            {
                if (isAuthorize(getOption($this->db), $user) && $user->rights->fournisseur->facture->lire
                    && $user->rights->fournisseur->facture->creer)
                {
                    print '<a class="butAction" href="' .
                        DOL_URL_ROOT . '/contrat/card.php?action=create&socid=' . $object->id . '&public_note=' . $object->public_note .
                        '&private_note=' . $object->private_note . '&options_supplier_contract=1">' .
                        $langs->trans("CreateFournContract") . '</a>';
                }
                else
                {
                    print '<a class="butActionRefused" href="#">' .
                        $langs->trans("CreateFournContract") . '</a>';

                }

            }

        }
    }

	/**
	 * Adds more actions buttons.
	 *
	 * @param   array()         $parameters     Hook metadatas (context, etc...)
	 * @param   CommonObject    $object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...
	 * @param   string          $action        Current action (if set). Generally create or edit or null
	 * @param   HookManager     $hookmanager    Hook manager propagated to allow calling another hook
	 * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
	 */
	function addMoreActionsButtons($parameters, &$object, &$action, $hookmanager)
	{
		global $langs, $form, $conf;

		$langs->load("contratplus@contratplus");

		dol_syslog('contratplus - addMoreActionsButtons activation', LOG_DEBUG);

		if ($parameters['currentcontext'] == 'contractcard')
		{
			$this->buttonContextContractCard($object, $action, $langs, $form, $conf);
		}
		if ($parameters['currentcontext'] == 'globalcard')
        {
            $this->buttonContextGlobalCard($object, $langs, $conf);
        }
		return 0;
	}

    /**
     * Hook called after form creation
     *
     * @param   array()         $parameters     Hook metadatas (context, etc...)
     * @param   CommonObject    $object        The object to process (an invoice if you are in invoice module, a propale in propale's module, etc...
     * @param   string          $action        Current action (if set). Generally create or edit or null
     * @return  int                             < 0 on error, 0 on success, 1 to replace standard code
     */
	function formObjectOptions($parameters, &$object, &$action)
    {
        global $db;

        if ($parameters['currentcontext'] == 'contractcard')
        {
            if ($action == 'create')
            {
                $extrafields = new ExtraFields($db);
                $extralabels = $extrafields->fetch_name_optionals_label($object->table_element);
                $extrafields->setOptionalsFromPost($extralabels, $object);
            }
        }
        return 0;
    }
}
