<?php

/**
 *       \file       htdocs/contrat/list.php
 *       \ingroup    contrat
 *       \brief      Page liste des contrats
 */

$res = 0;
if (! $res && file_exists("../main.inc.php")) $res=@include("../main.inc.php");         // to work if your module directory is into dolibarr root htdocs directory
if (! $res && file_exists("../../main.inc.php")) $res=@include("../../main.inc.php");       // to work if your module directory is into a subdir of root htdocs directory
if (! $res) die("Include of main fails");
require_once DOL_DOCUMENT_ROOT."/contrat/class/contrat.class.php";
require_once DOL_DOCUMENT_ROOT.'/core/class/html.formother.class.php';
require_once 'class/renew.class.php';
require_once 'core/function.php';

/**
 * Return the text to insert in $form->formconfirm() for renewal all confirmation
 *
 * @param   array           $selected   An array of ids selected for renewal
 * @param   Database        $db         The object given by dolibarr global (global $db)
 * @param   Lang            $langs      The object given by dolibarr global (global $langs)
 * @param   Conf            $conf       The object given by dolibarr global (global $conf)
 * @return  string
 */
function getRenewalAllConfirmation($selected, $db, $langs, $conf)
{
    $text = $langs->trans("RenewallAllConfirmation");
    foreach ($selected as $key => $id)
    {
        $contract = new Contrat($db);
        $societe = new Societe($db);

        $contract->fetch($id);
        $societe->fetch($contract->socid);
        $text .= '    - Contrat ' . $contract->ref . ' entreprise ' . $societe->name . ': Pour la date du ' .
            date('d/m/Y', $conf->global->CONTRATPLUS_DATE_END) . ';<br/> ';
    }

    return $text;
}

/**
 * Return the id of all contracts in Db
 *
 * @param   Database        $db         The object given by dolibarr global (global $db)
 * @return  array                       Ids of all contract
 */
function getContractIds($db)
{
    $sql = "SELECT llx_contrat.rowid FROM llx_contrat";
    $res = $db->query($sql);

    foreach ($res as $key => $contract)
        $ids[] = $contract['rowid'];

    return $ids;
}

/**
 * Retrun the id of all contracts selected in Db
 *
 * @param   Database        $db         The object given by dolibarr global (global $db)
 * @return  array                       Ids of all contract selected
 */
function getContractIdsSelected($db)
{
    $sql = "SELECT llx_contratplus.value AS 'rowid' FROM llx_contratplus WHERE llx_contratplus.name = 'RENEWAL_ID'";
    $res = $db->query($sql);

    foreach ($res as $key => $contract)
        $ids[] = $contract['rowid'];

    return $ids;
}

/**
 * Clear RENEWAL_ID on the table llx_contratplus
 *
 * @param   Database        $db         The object given by dolibarr global (global $db)
 * @return  int                         < 0 on error, > 0 on success
 */
function clearIdContratPlusTable($db)
{
    $sql = "DELETE FROM llx_contratplus WHERE llx_contratplus.name='RENEWAL_ID'";
    if ($db->query($sql) == null)
        return -1;
    return 1;
}

$now = dol_now();
$form = new Form($db);
$formother = new FormOther($db);
$socstatic = new Societe($db);

$langs->load("contracts");
$langs->load("products");
$langs->load("companies");
$langs->load("compta");
$langs->load("contratplus@contratplus");

$sortfield=GETPOST('sortfield','alpha');
$sortorder=GETPOST('sortorder','alpha');
$action = GETPOST("action");
$page=GETPOST('page','int');
if (!$page) { $page = 0 ; }
$limit = GETPOST('limit')?GETPOST('limit','int'):$conf->liste_limit;
$offset = $limit * $page ;

$search_name=GETPOST('search_name');
$search_contract=GETPOST('search_contract');
$sall=GETPOST('sall');
$search_status=GETPOST('search_status');
$socid=GETPOST('socid');
$search_sale=GETPOST('search_sale','int');
$search_product_category=GETPOST('search_product_category','int');

$month=GETPOST('month');
$year=GETPOST('year');
if(GETPOST('search_cli_four')!='') $search_cli_four=GETPOST('search_cli_four');
else $search_cli_four=-1;


$search_ref_customer=GETPOST('search_ref_customer','alpha');
$search_ref_supplier=GETPOST('search_ref_supplier','alpha');

$optioncss = GETPOST('optioncss','alpha');

// Defaut Sort
if (! $sortfield) $sortfield="c.rowid";
if (! $sortorder) $sortorder="DESC";

// Security check
$id=GETPOST('id','int');
if ($user->societe_id) $socid=$user->societe_id;
$result = restrictedArea($user, 'contrat', $id);

$staticcontrat=new Contrat($db);
$staticcontratligne=new ContratLigne($db);

$contextpage='contractlist';

// Initialize technical object to manage hooks of thirdparties. Note that conf->hooks_modules contains array array
$hookmanager->initHooks(array($contextpage));

$error = 0;
$errormsg = '';

/*
 * Action
 */

if (GETPOST("button_removefilter_x") || GETPOST("button_removefilter")) // Both test are required to be compatible with all browsers
{
	$search_name="";
	$search_contract="";
	$search_ref_supplier="";
    $search_ref_customer="";
    $search_sale='';
    $search_product_category='';
	$sall="";
	$search_status="";
    $search_cli_four="-1";
}

if ($search_status == '') $search_status=1;

// List of fields to search into when doing a "search in all"
$fieldstosearchall = array(
    'c.ref'=>'Ref',
    'c.ref_customer'=>'RefCustomer',
    'c.ref_supplier'=>'RefSupplier',
    's.nom'=>"ThirdParty",
    'cd.description'=>'Description',
    'c.note_public'=>'NotePublic',
    'c.note_private'=>'NotePrivate',
);

if (empty($user->socid)) $fieldstosearchall["c.note_private"]="NotePrivate";

$ids = getContractIds($db);

if ($action == "confirm_renewal_all")
{
    $option = getOption($db);
    $selected = getContractIdsSelected($db);
    if (selected != null) {
        $renew = new Renew($db, $conf, $user);
        $res = $renew->renewAll($option, $selected);
        if ($res < 0)
        {
            $error++;
            $errormsg = $langs->trans('ErrorRenewal');
        }
    }
    else
    {
        $error++;
        $errormsg = $langs->trans('NoContractSelected');
    }
}

//declare llx_header here to see form confirm
llxHeader();

if ($action == "choose")
{
    clearIdContratPlusTable($db);

    //search if contract is selected and add it to db
    foreach ($ids as $key => $id)
    {
        if (isset($_POST[$id]))
        {
            $selected[] = $id;
            $sql = "INSERT into llx_contratplus VALUES ('RENEWAL_ID','1','".$id."','Ce contrat est selectionné')";
            dol_syslog($sql, LOG_DEBUG);
            $db->query($sql);
        }
    }

    if (isset($selected)) {
        $text = getRenewalAllConfirmation($selected, $db, $langs, $conf);
        $url = $_SERVER["PHP_SELF"];
        print $form->formconfirm($url, $langs->trans("ValidRenewal"), $text, "confirm_renewal_all", '', 0, 1);
    }
    /*else
    {
        $error++;
        $errormsg = $langs->trans('NoContractSelected');
    }*/
}

/*
 * View
 */

$sqlview = 'SELECT';
$sqlview.= " c.rowid as cid, c.ref, c.datec, c.date_contrat, c.statut, c.ref_customer, c.ref_supplier, c.note_public, c.note_private,";
$sqlview.= " s.nom as name, s.rowid as socid,";
$sqlview.= ' SUM('.$db->ifsql("cd.statut=0",1,0).') as nb_initial,';
$sqlview.= ' SUM('.$db->ifsql("cd.statut=4 AND (cd.date_fin_validite IS NULL OR cd.date_fin_validite >= '".$db->idate($now)."')",1,0).') as nb_running,';
$sqlview.= ' SUM('.$db->ifsql("cd.statut=4 AND (cd.date_fin_validite IS NOT NULL AND cd.date_fin_validite < '".$db->idate($now)."')",1,0).') as nb_expired,';
$sqlview.= ' SUM('.$db->ifsql("cd.statut=4 AND (cd.date_fin_validite IS NOT NULL AND cd.date_fin_validite < '".$db->idate($now - $conf->contrat->services->expires->warning_delay)."')",1,0).') as nb_late,';
$sqlview.= ' SUM('.$db->ifsql("cd.statut=5",1,0).') as nb_closed';
$sqlview.= " FROM ".MAIN_DB_PREFIX."societe as s";
if ($search_sale > 0 || (! $user->rights->societe->client->voir && ! $socid)) $sqlview .= ", ".MAIN_DB_PREFIX."societe_commerciaux as sc";
$sqlview.= ", ".MAIN_DB_PREFIX."contrat as c";
$sqlview.= " LEFT JOIN ".MAIN_DB_PREFIX."contratdet as cd ON c.rowid = cd.fk_contrat";
if ($search_product_category > 0) $sqlview.= ' LEFT JOIN '.MAIN_DB_PREFIX.'categorie_product as cp ON cp.fk_product=cd.fk_product';
$sqlview.= " WHERE c.fk_soc = s.rowid ";
$sqlview.= ' AND c.entity IN ('.getEntity('contract', 1).')';
if ($search_product_category > 0) $sqlview.=" AND cp.fk_categorie = ".$search_product_category;
if ($socid) $sqlview.= " AND s.rowid = ".$db->escape($socid);
if (!$user->rights->societe->client->voir && !$socid) $sqlview.= " AND s.rowid = sc.fk_soc AND sc.fk_user = " .$user->id;

if ($search_name) {
    $sqlview .= natural_search('s.nom', $search_name);
}

if ($search_cli_four!='-1')
    $sqlview .= " AND s.fournisseur = ".$search_cli_four;

if ($search_contract) {
    $sqlview .= natural_search(array('c.rowid', 'c.ref'), $search_contract);
}
if ($search_ref_supplier) {
	$sqlview .= natural_search(array('c.ref_supplier'), $search_ref_supplier);
}
if ($search_ref_customer) {
    $sqlview .= natural_search(array('c.ref_customer'), $search_ref_customer);
}
if ($search_sale > 0)
{
	$sqlview.= " AND s.rowid = sc.fk_soc AND sc.fk_user = " .$search_sale;
}
if ($sall) {
    $sqlview .= natural_search(array_keys($fieldstosearchall), $sall);
}
$sqlview.= " GROUP BY c.rowid, c.ref, c.datec, c.date_contrat, c.statut, c.ref_supplier, s.nom, s.rowid";
$totalnboflines=0;
$result=$db->query($sqlview);
if ($result)
{
    $totalnboflines = $db->num_rows($result);
}
$sqlview.= $db->order($sortfield,$sortorder);

$sqlview.= $db->plimit($limit + 1, $offset);

$resql=$db->query($sqlview);
if ($resql)
{
    $num = $db->num_rows($resql);
    $i = 0;

    print '<form method="post" action="'.$_SERVER["PHP_SELF"].'?action=choose" name="FormContrat">';

    print_barre_liste($langs->trans("ContratPlusindex"), $page, $_SERVER["PHP_SELF"], '&search_contract='.$search_contract.'&search_name='.$search_name, $sortfield, $sortorder,'',$num,$totalnboflines,'object_contract.png',0,'','',$limit);

    // DEBUG
    if($conf->global->MAIN_FEATURES_LEVEL=='3') {
        print '<table class="noborder">';
        print '<tr><td><h2>DEBUG</h2></td></tr>';
        print '<tr><td><b>SQL : </b>'.$sqlview.'</td></tr>';
        print '<tr><td><b>PARAM : </b>'.$param.'</td></tr>';
        print '<tr><td><b>RREF :</b>'.GETPOST('search_ref_customer').'</td></tr>';
        print '</table>';
    }

    // if ($sall)
    // {
    //     foreach($fieldstosearchall as $key => $val) $fieldstosearchall[$key]=$langs->trans($val);
    //     print $langs->trans("FilterOnInto", $all) . join(', ',$fieldstosearchall);
    // }

    // If the user can view prospects other than his'
    $moreforfilter='';
    // Filtre Client / Fournisseur
    if ($user->rights->societe->client->voir & $user->rights->fournisseur->lire)
    {
        $moreforfilter.='<div class="divsearchfield">';
        $moreforfilter.=$langs->trans('ContratAllClientFournisseur');
        $moreforfilter.=' <select class="flat minwidth100 maxwidth300" id="search_cli_four" name="search_cli_four">
        <option value="-1" '.($search_cli_four=="-1"?"selected":"").'>'.$langs->trans('All').'</option>
        <option value="0" '.($search_cli_four=="0"?"selected":"").'>'.$langs->trans('Client').'</option>
        <option value="1" '.($search_cli_four=="1"?"selected":"").'>'.$langs->trans('Fournisseur').'</option>
        </select>';
        $moreforfilter.='</div>';
    }

    /*if ($user->rights->societe->client->voir || $socid)
    {
        $langs->load("commercial");
        $moreforfilter.='<div class="divsearchfield">';
        $moreforfilter.=$langs->trans('ThirdPartiesOfSaleRepresentative'). ': ';
        $moreforfilter.=$formother->select_salesrepresentatives($search_sale,'search_sale',$user,0,1,'maxwidth300');
        $moreforfilter.='</div>';
    }*/
    // If the user can view categories of products
    if ($conf->categorie->enabled && ($user->rights->produit->lire || $user->rights->service->lire))
    {
        include_once DOL_DOCUMENT_ROOT.'/categories/class/categorie.class.php';
        $moreforfilter.='<div class="divsearchfield">';
        $moreforfilter.=$langs->trans('IncludingProductWithTag'). ': ';
        $cate_arbo = $form->select_all_categories(Categorie::TYPE_PRODUCT, null, 'parent', null, null, 1);
        $moreforfilter.=$form->selectarray('search_product_category', $cate_arbo, $search_product_category, 1, 0, 0, '', 0, 0, 0, 0, '', 1);
        $moreforfilter.='</div>';
    }
    

    $parameters=array();
    $reshook=$hookmanager->executeHooks('printFieldPreListTitle',$parameters);    // Note that $action and $object may have been modified by hook
	if (empty($reshook)) $moreforfilter .= $hookmanager->resPrint;
	else $moreforfilter = $hookmanager->resPrint;
    if (! empty($moreforfilter))
    {
        print '<div class="liste_titre liste_titre_bydiv centpercent">';
        print $moreforfilter;
        print '</div>';
    }

    $param='&search_contract='.$search_contract;
    $param.='&search_name='.$search_name;
    $param.='&search_ref_supplier='.$search_ref_supplier;
    $param.='&search_ref_customer='.$search_ref_customer;
    if ($search_sale)
        $param.='&search_sale='.$search_sale;

    if ($search_cli_four != '-1')
        $param.='&search_cli_four='.$search_cli_four;

    if ($search_product_category)
        $param.='&search_product_category='.$search_product_category;

    if ($optioncss != '')
        $param.='&optioncss='.$optioncss;

    print '<table class="noborder tagtable liste'.($moreforfilter?" listwithfilterbefore":"").'">';

    print '<tr class="liste_titre">';
    print_liste_field_titre('');
    print_liste_field_titre($langs->trans("Contract"), $_SERVER["PHP_SELF"], "c.rowid","",$param,'',$sortfield,$sortorder);
    print_liste_field_titre($langs->trans("RefCustomer"), $_SERVER["PHP_SELF"], "c.ref_customer","",$param,'',$sortfield,$sortorder);
    print_liste_field_titre($langs->trans("RefSupplier"), $_SERVER["PHP_SELF"], "c.ref_supplier","",$param,'',$sortfield,$sortorder);
    print_liste_field_titre($langs->trans("Company"), $_SERVER["PHP_SELF"], "s.nom","",$param,'',$sortfield,$sortorder);
    print_liste_field_titre($langs->trans("SalesRepresentative"), $_SERVER["PHP_SELF"],"","",$param,'',$sortfield,$sortorder);
    print_liste_field_titre($langs->trans("DateContract"), $_SERVER["PHP_SELF"], "c.date_contrat","",$param,' align="center"',$sortfield,$sortorder);
    print_liste_field_titre($staticcontratligne->LibStatut(0,3), '', '', '', '', 'width="16"');
    print_liste_field_titre($staticcontratligne->LibStatut(4,3,0), '', '', '', '', 'width="16"');
    print_liste_field_titre($staticcontratligne->LibStatut(4,3,1), '', '', '', '', 'width="16"');
    print_liste_field_titre($staticcontratligne->LibStatut(5,3), '', '', '', '', 'width="16"');
    print_liste_field_titre('Info', '', '', '', '', 'width="8" align="center"');
    print_liste_field_titre('',$_SERVER["PHP_SELF"],"",'','','',$sortfield,$sortorder,'maxwidthsearch ');
    print_liste_field_titre('', $_SERVER["PHP_SELF"],'','','','',$sortfield,$sortorder); //perso
    print "</tr>";

    print '<input type="hidden" name="token" value="'.$_SESSION['newtoken'].'">';
    print '<tr class="liste_titre">';
    print '<td></td>';
    print '<td class="liste_titre">';
    print '<input type="text" class="flat" size="15" name="search_contract" value="'.dol_escape_htmltag($search_contract).'">';
    print '</td>';
    print '<td class="liste_titre">';
    print '<input type="text" class="flat" size="6" name="search_ref_customer" value="'.dol_escape_htmltag($search_ref_customer).'">';
    print '</td>';
    print '<td class="liste_titre">';
    print '<input type="text" class="flat" size="6" name="search_ref_supplier" value="'.dol_escape_htmltag($search_ref_supplier).'">';
    print '</td>';
    print '<td class="liste_titre">';
    print '<input type="text" class="flat" size="20" name="search_name" value="'.dol_escape_htmltag($search_name).'">';
    print '</td>';
    print '<td>';
    print $formother->select_salesrepresentatives($search_sale,'search_sale',$user,0,1,'maxwidth300');
    print '</td>';
    // Date contract
    print '<td align="center">';
    // if (! empty($conf->global->MAIN_LIST_FILTER_ON_DAY)) print '<input class="flat" type="text" size="1" maxlength="2" name="day" value="'.$day.'">';
    // print '<input class="flat" type="text" size="2" maxlength="2" name="month" value="'.$month.'">';
    // $formother->select_year($year,'year',1, 20, 5);
    // print '</td>';
    print '<td class="liste_titre" colspan="5" align="right">';
    print '</td>';
    print '<td>';
    $searchpitco=$form->showFilterAndCheckAddButtons(0);
    print $searchpitco;
    print '</td>';
    print '<td class="liste_titre"></td>';
    print "</tr>\n";

    $var=true;
    while ($i < min($num,$limit))
    {
        $obj = $db->fetch_object($resql);
        $var=!$var;
        if (isSupplierContract($db, $obj->cid)) {
            print '<tr ' . substr($bc[$var], 0, -1) . ' supplier"' . '>';
            print '<td>' . img_object($langs->trans('SupplierContract'),"sending") . '</td>';
        }
        else {
            print '<tr ' . $bc[$var] . '>';
            print '<td>' . img_object($langs->trans('CustomerContract'),"user") . '</td>';
        }


        print '<td class="nowrap"><a href="'.DOL_URL_ROOT.'/contrat/card.php?id='.$obj->cid.'">';
        print img_object($langs->trans("ShowContract"),"contract").' '.(isset($obj->ref) ? $obj->ref : $obj->cid) .'</a>';
        if ($obj->nb_late) print img_warning($langs->trans("Late"));
        print '</td>';
        print '<td>'.$obj->ref_customer.'</td>';
        print '<td>'.$obj->ref_supplier.'</td>';
        print '<td><a href="../../comm/card.php?socid='.$obj->socid.'">'.img_object($langs->trans("ShowCompany"),"company").' '.$obj->name.'</a></td>';

        // Sales Rapresentatives
        print '<td>';
        if($obj->socid)
        {
        	$socstatic->fetch($obj->socid);
        	$listsalesrepresentatives=$socstatic->getSalesRepresentatives($user);
        	$nbofsalesrepresentative=count($listsalesrepresentatives);
        	if ($nbofsalesrepresentative > 3)   // We print only number
        	{
        		print '<a href="'.DOL_URL_ROOT.'/societe/commerciaux.php?socid='.$socstatic->id.'">';
        		print $nbofsalesrepresentative;
        		print '</a>';
        	}
        	else if ($nbofsalesrepresentative > 0)
        	{
        		$userstatic=new User($db);
        		$j=0;
        		foreach($listsalesrepresentatives as $val)
        		{
        			$userstatic->id=$val['id'];
        			$userstatic->lastname=$val['lastname'];
        			$userstatic->firstname=$val['firstname'];
        			print '<div class="float">'.$userstatic->getNomUrl(1);
        			$j++;
        			if ($j < $nbofsalesrepresentative) print ', ';
        			print '</div>';
        		}
        	}
        	else print $langs->trans("NoSalesRepresentativeAffected");
        }
        else
        {
        	print '&nbsp';
        }
        print '</td>';
        print '<td align="center">'.dol_print_date($db->jdate($obj->date_contrat)).'</td>';
        print '<td align="center">'.($obj->nb_initial>0?$obj->nb_initial:'').'</td>';
        print '<td align="center">'.($obj->nb_running>0?$obj->nb_running:'').'</td>';
        print '<td align="center">'.($obj->nb_expired>0?$obj->nb_expired:'').'</td>';
        print '<td align="center">'.($obj->nb_closed>0 ?$obj->nb_closed:'').'</td>';
        print '<td align="center">'.(empty($obj->note_private)?'':img_warning($obj->note_private)).'</td>';
        print '<td></td>';
        print '<td>';
        print '<input type="checkbox" name="'.$obj->cid.'" id="'.$obj->cid.'">'; // Renewal All
        print '</td>';
        print "</tr>\n";
        $i++;
    }

    $db->free($resql);

    $supplier_ok = true;
    if ($conf->global->CONTRATPLUS_SUPPLIER_CONTRACT == 1)
    {
        $supplier_ok = false;
        if ($user->rights->fournisseur->facture->lire
            && $user->rights->fournisseur->facture->creer
            && $user->rights->fournisseur->facture->creer)
            $supplier_ok = true;
    }
    if (isAuthorize(getOption($db), $user) && $supplier_ok)
        print '<tr><td colspan="13" align="center"><input type="submit" name="submit" value="'.$langs->trans('RenewContrat').'" class="button"></td><tr>';
    else
        print '<tr><td colspan="13" align="center"><input type="submit" name="submit" value="'.$langs->trans('RenewContrat').'" class="buttonRefused" disabled></td><tr>';

    print '</form>';

    print '</table>';

    print '<table class="noborder" width="100%">';

    print '<tr class="liste_titre"><td colspan="4">'.$langs->trans('RenewContratinfo').'</td></tr>';

    print '<tr class="impair"><td>'.$langs->trans('ContratPlusDateStart');
    print '</td><td>'.dol_print_date($conf->global->CONTRATPLUS_DATE_START);
    print '</td>';

    print '<td>'.$langs->trans('ContratPlusDateEnd');
    print '</td><td>'.dol_print_date($conf->global->CONTRATPLUS_DATE_END);
    print '</td></tr>';

    print '<tr class="impair"><td>'.$langs->trans('ContratPlusBillDate');
    print '</td><td colspan="3">'.dol_print_date($conf->global->CONTRATPLUS_BILL_DATE);
    print '</td></tr>';

    print '<tr class="impair"><td colspan="2">'.$langs->trans('ContratPlusBillNote');
    print '</td><td colspan="2">'.$conf->global->CONTRATPLUS_BILL_NOTE;
    print '</td></tr>';

    print '<tr class="impair"><td colspan="2">'.$langs->trans('ContratPlusBillNotePrivate');
    print '</td><td colspan="2">'.$conf->global->CONTRATPLUS_BILL_NOTE_PRIVATE;
    print '</td></tr>';

    print '</table>';

    if ($error > 0)
        dol_htmloutput_mesg($errormsg, '', 'error');
}
else
{
    dol_print_error($db);
}

llxFooter();
$db->close();
